// Documentation examples
net from http://labs.fhcrc.org/pepe/stata/
use http://labs.fhcrc.org/pepe/book/data/nnhs2

rocreg d y1, cluster(id) noccsamp
rocreg d y1, adjcov(gender) regcov(gender) cluster(id) noccsamp level(90)
rocreg d y1, adjcov(gender) regcov(gender) cluster(id) noccsamp pvcmeth(normal)
rocreg d y1 y2, adjcov(currage gender) regcov(currage) cluster(id) noccsamp adjmodel(linear)
rocreg d y1, adjcov(gender) regcov(gender) sregcov(gender) cluster(id) link(logit) noccsamp


// Covariate adjustment
gen dis = d
gen m1 = y1
gen m2 = y2
gen m3 = y3

// One marker
rocreg d m1, adjcov(gender) adjmodel(stratified) pvcmeth(empirical)
test alpha_0
test alpha_1
rocreg d m1, adjcov(gender) adjmodel(stratified) pvcmeth(normal) nsamp(100)
rocreg d m1, adjcov(y2) adjmodel(linear) pvcmeth(normal) nsamp(100)
rocreg d m1, adjcov(y2) adjmodel(linear) nsamp(100)

// Multiple markers
rocreg dis y1 y2, adjcov(gender) adjmodel(stratified) pvcmeth(empirical) nsamp(100)
test alpha_0
test alpha_1
rocreg dis y1 y2, adjcov(gender) adjmodel(stratified) pvcmeth(normal) nsamp(100)
rocreg dis y1 y2, adjcov(m3) adjmodel(linear) nsamp(100)
rocreg dis y1 y2, adjcov(m3) adjmodel(linear) pvcmeth(normal) nsamp(100)


// Multiple adjcov variables
rocreg d y1, adjcov(gender sitenum) adjmodel(stratified) pvcmeth(empirical) nsamp(100)
test alpha_0
test alpha_1
rocreg d y1, adjcov(gender sitenum) adjmodel(stratified) pvcmeth(normal) nsamp(100)
rocreg d y1, adjcov(y3 currage) adjmodel(linear) pvcmeth(normal) nsamp(100)
rocreg d y1, adjcov(y3 currage) adjmodel(linear) nsamp(100)

// nostsamp
rocreg d y1, adjcov(gender sitenum) adjmodel(stratified) pvcmeth(empirical) nsamp(100) nostsamp
rocreg d y1, adjcov(gender sitenum) adjmodel(stratified) pvcmeth(normal) nsamp(100) nostsamp





clear
// Pancreatic cancer data set, more options
use http://labs.fhcrc.org/pepe/book/data/wiedat2b
//infile using "http://www.fhcrc.org/science/labs/pepe/book/data/wiedat2b.dta"
rocreg d y1, tiecorr nsamp(100)
rocreg d y1, regcov(y2) nsamp(100)
rocreg d y1, regcov(y2) sregcov(y2) nsamp(100)
test alpha_0
test alpha_1
test y2
rocreg d y1, pvcmeth(normal) nsamp(100)

//Link function and interval
rocreg d y1, interval(0 0.1 10) link(probit)
rocreg d y1, link(logit)
rocreg d y1, interval(0 0.1 10) link(logit)

//Bootstrap options
rocreg d y1, noccsamp nsamp(500)

//resfile
gen dis = d
//1 marker - create file
rocreg dis y1, nsamp(100) resfile(testResfileRocreg) replace
//1 marker - Try to overwrite existing file
//rocreg dis y2, nsamp(100) resfile(testResfileRocreg)
//Multiple markers
rocreg dis y1 y2, nsamp(100) resfile(testResfileRocreg) replace
//Multiple markers - Try to overwrite existing file
//rocreg dis y1 y2, nsamp(100) resfile(testResfileRocreg)



clear
// Ovarian Cancer dataset
use http://labs.fhcrc.org/pepe/book/data/ocdata_b
//infile using "http://www.fhcrc.org/science/labs/pepe/book/data/ocdata_b.dta"
rocreg d y1 y2
rocreg d y1, tiecorr pvcmeth(empirical)
rocreg d y1, link(logit)


clear
// Daryl error - CIs don't contain estimate
//use http://labs.fhcrc.org/pepe/book/data/sj_ms2_fig1_scen1b
use http://labs.fhcrc.org/pepe/dabs/sj_ms2_fig1_scen1b
//infile using "http://labs.fhcrc.org/pepe/dabs/sj_ms2_fig1_scen1b.dta", clear
rocreg d y, level(95) nsamp(100)
rocreg d y, level(95) nsamp(100) adjcov(z) adjmodel(stratified)
